"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
function contentLengthMiddleware(bodyLengthCalculator) {
    var _this = this;
    return function (next) { return function (args) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
        var request, body, headers, length;
        return tslib_1.__generator(this, function (_a) {
            request = tslib_1.__assign({}, args.request);
            body = request.body, headers = request.headers;
            if (body &&
                Object.keys(headers)
                    .map(function (str) { return str.toLowerCase(); })
                    .indexOf("content-length") === -1) {
                length = bodyLengthCalculator(body);
                if (length !== undefined) {
                    request.headers = tslib_1.__assign({}, request.headers, { "Content-Length": String(length) });
                }
            }
            return [2 /*return*/, next(tslib_1.__assign({}, args, { request: request }))];
        });
    }); }; };
}
exports.contentLengthMiddleware = contentLengthMiddleware;
//# sourceMappingURL=index.js.map